package org.eclipse.atf.mozilla.ide.ui.domwatcher.model;

import org.mozilla.interfaces.nsIDOMEvent;

/**
 * This interface is use to calculate the Detail string for a particular 
 * event type. Each subclass of nsIDOMEvent might have different members that
 * are used to provide more information about the event. 
 * 
 * @author Gino Bustelo
 *
 */
public interface IDOMEventDetailProvider {

	/*
	 * Returns a String for detail information about the event
	 */
	String getDetail( nsIDOMEvent event );
}
